unit demo_u;

{ ENGLISH:

  It is Main Form of the demo project.  It demonstrate a features of
  "chemical" components ChemLabel, ChemListBox, ChemComboBox, 
  DBChemText, DBChemComboBox, DBChemListBox and of the class ChemString 
  in representation of a string type in the customary chemists style. 
  For successful compilation you need:
    1) Delphi 3
    2) package CHEM installed in it 
    3) registered in PATH or in Library_Path 
       (Tools\Environment_Options\Library) path to files chembase.dcu, 
       stdchems.dcu, dbchems.dcu. This condition, most likely, was 
       already automatically carried out by Delphi, when you 
       install CHEM.DPL (if all these files were in one directory).
  The program does not use the module QRChems (component QRChemLabel 
  and QRDBChemText) in order to prevent of troubles for developers, 
  which resolutely have deleted QuickReport from the environment.
  The form contains some pages: 
    Labels - comparison of a behaviour ChemLabel and Label for want 
      of various values of common and individual properties. Try change
      them in run-time, using the controls from a right part of page.
    Boxes - also comparison ChemListBox and ListBox, ChemComboBox and
      ComboBox. However here is not submitted of the same broad 
      possibilities to change properties in run-time. But you may do it
      in design-time. In run-time it is possible to change "chemical" 
      properties (at the bottom) and structure of the lists (ComboBox 
      and buttons).
    DBChems - data aware "chemical" components are connected to table 
      DEMO.DB from the project directory. For navigation DBNavigator 
      (at the upper right) is added. The initial filling of the lists 
      happens from database for want of discovery of the form.
    Grid Example - simple example of use ChemString in handling of an 
      event StringGrid.OnDrawCell for want of various values it of 
      "chemical" properties. 
    DBGrid Example - practically the same, but for DBGrid, connected 
      with the already familiar table, and without a variation of 
      "chemical" properties.
    Others - some more very simple solutions, integrated intention 
      "chemicalizing" of components VCL. 

  For more careful study it is possible to advise an universal method - 
  creative processing VCL sources and use of ChemString features.
}

{ RUSSIAN:

    ,   ""
   ChemLabel, ChemListBox, ChemComboBox, DBChemText,
  DBChemComboBox, DBChemListBox   ChemString  
       .  
    ,   ,    
    .        
        .    ,
     .     :
        1) Delphi 3
        2)    package CHEM
        3)   PATH   Library_Path (Tools\Environment_Options\Library)
              chembase.dcu, stdchems.dcu, dbchems.dcu. 
           ,  ,     Delphi,
              CHEM.DPL (      
           ).
      QRChems ( QRChemLabel  QRDBChemText)
       ,   
  QuickReport   .
     :
        Labels -   ChemLabel  Label  
                     . 
                    run-time,   
                    .
        Boxes  -   ChemListBox c ListBox, ChemComboBox c ComboBox.
                        
                    run-time (   ,   
                 ?).      -  ,  
                 ,  design-time.  run-time   ""
                  (  )    (ComboBox  ).
       DBChems - data aware -  ""   
                  DEMO.DB   .    
                  DBNavigator ( ).  
                       .
  Grid Example -    ChemString   
                 StringGrid.OnDrawCell     ""
                 .    "" 
                    VCL.  , , 
                     ""
                    TryCorrect  SubPercent.
DBGrid Example -    ,   DBGrid,   
                  ,    "" .
        Others -     ,  
                 ""  VCL.     
                  ,        .
                       -
                   -    VCL 
                   ChemString.
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, StdCtrls, ComCtrls, Mask, Db, DBTables, DBCtrls, DBGrids,

  ChemBase, StdChems, DBChems;   { "chemical" units }

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Label2: TLabel;
    Splitter1: TSplitter;
    Panel7: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Label6: TLabel;
    MaskEdit1: TMaskEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    ComboBox2: TComboBox;
    Label13: TLabel;
    ComboBox3: TComboBox;
    CheckBox1: TCheckBox;
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    Button1: TButton;
    Button2: TButton;
    Panel8: TPanel;
    Panel9: TPanel;
    CheckBox2: TCheckBox;
    Label14: TLabel;
    MaskEdit2: TMaskEdit;
    Label15: TLabel;
    ComboBox4: TComboBox;
    Label16: TLabel;
    MaskEdit3: TMaskEdit;
    Label17: TLabel;
    MaskEdit4: TMaskEdit;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label18: TLabel;
    MaskEdit5: TMaskEdit;
    Label19: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    Panel6: TPanel;
    ChemLabel1: TChemLabel;
    Label1: TLabel;
    TabSheet2: TTabSheet;
    Panel10: TPanel;
    Splitter2: TSplitter;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    ListBox1: TListBox;
    ChemListBox1: TChemListBox;
    Panel19: TPanel;
    Label30: TLabel;
    Label31: TLabel;
    ComboBox5: TComboBox;
    MaskEdit6: TMaskEdit;
    Label32: TLabel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    ComboBox6: TComboBox;
    ChemComboBox1: TChemComboBox;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
    BtnAdd: TButton;
    BtnRmv: TButton;
    TabSheet3: TTabSheet;
    Panel24: TPanel;
    Panel25: TPanel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    ComboBox7: TComboBox;
    MaskEdit7: TMaskEdit;
    Panel26: TPanel;
    Panel27: TPanel;
    Panel28: TPanel;
    Splitter5: TSplitter;
    Panel29: TPanel;
    Panel30: TPanel;
    Panel31: TPanel;
    Splitter6: TSplitter;
    Panel32: TPanel;
    DBNavigator1: TDBNavigator;
    Panel33: TPanel;
    Table1: TTable;
    DataSource1: TDataSource;
    DBChemListBox1: TDBChemListBox;
    DBChemText1: TDBChemText;
    DBChemComboBox1: TDBChemComboBox;
    Table1Name: TStringField;
    TabSheet4: TTabSheet;
    Panel34: TPanel;
    StringGrid1: TStringGrid;
    TabSheet5: TTabSheet;
    DBGrid1: TDBGrid;
    TabSheet6: TTabSheet;
    StringGrid2: TStringGrid;
    Edit2: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    CheckBox5: TCheckBox;
    ChemLabel2: TChemLabel;
    CheckBox6: TCheckBox;
    RadioButton1: TRadioButton;
    ChemLabel3: TChemLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    RadioButton2: TRadioButton;
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GetCorrect;
    procedure MaskEdit1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure MaskEdit2Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure MaskEdit3Change(Sender: TObject);
    procedure Panel5Resize(Sender: TObject);
    procedure MaskEdit4Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure MaskEdit5Change(Sender: TObject);
    procedure SetSize;
    procedure SetLabelsPage;
    procedure Panel23Resize(Sender: TObject);
    procedure Panel22Resize(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure MaskEdit6Change(Sender: TObject);
    procedure ComboBox6Change(Sender: TObject);
    procedure BtnAddClick(Sender: TObject);
    procedure BtnRmvClick(Sender: TObject);
    procedure Panel30Resize(Sender: TObject);
    procedure SetBoxesPage;
    procedure SetDBPage;
    procedure ComboBox7Change(Sender: TObject);
    procedure MaskEdit7Change(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure SetGrid;
    procedure Panel34Resize(Sender: TObject);
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure StringGrid2DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ChemLabel2Click(Sender: TObject);
    procedure ChemLabel3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  LoadLabels, SetAutoSize, LoadLists : boolean;

implementation

{$R *.DFM}

procedure TForm1.SetSize;
begin
  if LoadLabels then exit;
  MaskEdit3.Text:=IntToStr(Label1.Left);
  MaskEdit4.Text:=IntToStr(Label1.Top);
  MaskEdit2.Text:=IntToStr(ChemLabel1.Height);
  MaskEdit5.Text:=IntToStr(ChemLabel1.Width);
end;

procedure TForm1.GetCorrect;
const a:array [TChemCorrect] of string = ('chmInvalid', 'chmPossible','chmCorrect');
begin
  Label8.Caption:=a[ChemLabel1.Correct];
  SetSize;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  Label1.Caption:=Edit1.Text;
  ChemLabel1.Caption:=Edit1.Text;
  GetCorrect;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if not (ComboBox1.ItemIndex in [0..2]) then ComboBox1.ItemIndex:=2;
  ChemLabel1.TryCorrect:=TChemTryCorrect(ComboBox1.ItemIndex);
  Edit1Change(NIL);
  GetCorrect;
end;

procedure TForm1.MaskEdit1Change(Sender: TObject);
begin
  ChemLabel1.SubPercent:=StrToInt(MaskEdit1.Text);
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  if not (ComboBox2.ItemIndex in [0..5]) then ComboBox2.ItemIndex:=0;
  ChemLabel1.Align:=TAlign(ComboBox2.ItemIndex);
  Label1.Align:=TAlign(ComboBox2.ItemIndex);
  SetSize;
end;

procedure TForm1.ComboBox3Change(Sender: TObject);
begin
  if not (ComboBox3.ItemIndex in [0..2]) then ComboBox3.ItemIndex:=0;
  ChemLabel1.Alignment:=TAlignment(ComboBox3.ItemIndex);
  Label1.Alignment:=TAlignment(ComboBox3.ItemIndex);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  SetAutoSize:=True;
  ChemLabel1.Autosize:=CheckBox1.Checked;
  Label1.Autosize:=CheckBox1.Checked;
  SetSize;
  SetAutoSize:=False;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then begin
    ChemLabel1.Color:=ColorDialog1.Color;
    Label1.Color:=ColorDialog1.Color;
    Button1.Font.Color:=ColorDialog1.Color;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if FontDialog1.Execute then begin
    ChemLabel1.Font:=FontDialog1.Font;
    Label1.Font:=FontDialog1.Font;
    Button2.Font:=FontDialog1.Font;
  end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  ChemLabel1.Enabled:=CheckBox2.Checked;
  Label1.Enabled:=CheckBox2.Checked;
end;

procedure TForm1.MaskEdit2Change(Sender: TObject);
begin
  if SetAutoSize then exit;
  ChemLabel1.Height:=StrToInt(MaskEdit2.Text);
  Label1.Height:=StrToInt(MaskEdit2.Text);
  CheckBox1.Checked:=False;
end;

procedure TForm1.ComboBox4Change(Sender: TObject);
begin
  if not (ComboBox4.ItemIndex in [0..2]) then ComboBox4.ItemIndex:=0;
  ChemLabel1.Layout:=TTextLayout(ComboBox4.ItemIndex);
  Label1.Layout:=TTextLayout(ComboBox4.ItemIndex);
end;

procedure TForm1.MaskEdit3Change(Sender: TObject);
begin
  ChemLabel1.Left:=StrToInt(MaskEdit3.Text);
  Label1.Left:=StrToInt(MaskEdit3.Text);
end;

procedure TForm1.Panel5Resize(Sender: TObject);
begin
  Panel8.Height:=(Panel5.ClientHeight div 2);
  Panel9.Height:=Panel8.Height;
  SetSize;
end;

procedure TForm1.MaskEdit4Change(Sender: TObject);
begin
  ChemLabel1.Top:=StrToInt(MaskEdit4.Text);
  Label1.Top:=StrToInt(MaskEdit4.Text);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  ChemLabel1.Transparent:=CheckBox3.Checked;
  Label1.Transparent:=CheckBox3.Checked;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  ChemLabel1.Visible:=CheckBox4.Checked;
  Label1.Visible:=CheckBox4.Checked;
end;

procedure TForm1.MaskEdit5Change(Sender: TObject);
begin
  if SetAutoSize then exit;
  ChemLabel1.Width:=StrToInt(MaskEdit5.Text);
  Label1.Width:=StrToInt(MaskEdit5.Text);
  CheckBox1.Checked:=False;
end;

procedure TForm1.SetLabelsPage;
begin
  LoadLabels:=True;
  ComboBox1Change(NIL);
  ComboBox2Change(NIL);
  ComboBox3Change(NIL);
  ComboBox4Change(NIL);
  CheckBox1Click(NIL);
  CheckBox2Click(NIL);
  CheckBox3Click(NIL);
  CheckBox4Click(NIL);
  Edit1Change(NIL);
  MaskEdit1Change(NIL);
  MaskEdit2Change(NIL);
  MaskEdit3Change(NIL);
  MaskEdit4Change(NIL);
  MaskEdit5Change(NIL);
  LoadLabels:=False;
  SetSize;
end;

procedure TForm1.SetBoxesPage;
begin
  ComboBox5Change(NIL);
  MaskEdit6Change(NIL);
  ChemComboBox1.ItemIndex:=0;
  ComboBox6.ItemIndex:=0;
end;

procedure TForm1.SetDBPage;
begin
  ComboBox7Change(NIL);
  MaskEdit7Change(NIL);
  Table1.DisableControls;
  while not Table1.EOF do begin
    DBChemComboBox1.Items.Add(Table1Name.AsString);
    Table1.Next;
  end;
  Table1.First;
  DBChemListBox1.Items.Assign(DBChemComboBox1.Items);
  Table1.EnableControls;
end;

procedure TForm1.Panel23Resize(Sender: TObject);
begin
  ComboBox6.Width:=Panel23.ClientWidth;
end;

procedure TForm1.Panel22Resize(Sender: TObject);
begin
  ChemComboBox1.Width:=Panel22.ClientWidth;
end;

procedure TForm1.ComboBox5Change(Sender: TObject);
begin
  if not (ComboBox5.ItemIndex in [0..2]) then ComboBox5.ItemIndex:=2;
  ChemListBox1.TryCorrect:=TChemTryCorrect(ComboBox5.ItemIndex);
  ChemComboBox1.TryCorrect:=TChemTryCorrect(ComboBox5.ItemIndex);
end;

procedure TForm1.MaskEdit6Change(Sender: TObject);
begin
  ChemListBox1.SubPercent:=StrToInt(MaskEdit6.Text);
  ChemComboBox1.SubPercent:=StrToInt(MaskEdit6.Text);
end;

procedure TForm1.ComboBox6Change(Sender: TObject);
begin
  with ComboBox6.Items do
    BtnAdd.Enabled:=(IndexOf(ComboBox6.Text)<0);
  BtnRmv.Enabled:=not BtnAdd.Enabled;  
end;

procedure TForm1.BtnAddClick(Sender: TObject);
begin
  ListBox1.Items.Add(ComboBox6.Text);
  ChemListBox1.Items.Add(ComboBox6.Text);
  ChemComboBox1.Items.Add(ComboBox6.Text);
  ComboBox6.Items.Add(ComboBox6.Text);
  ComboBox6Change(NIL);
end;

procedure TForm1.BtnRmvClick(Sender: TObject);
begin
  with ListBox1.Items do Delete(IndexOf(ComboBox6.Text));
  with ChemListBox1.Items do Delete(IndexOf(ComboBox6.Text));
  with ChemComboBox1.Items do Delete(IndexOf(ComboBox6.Text));
  with ComboBox6.Items do Delete(IndexOf(ComboBox6.Text));
end;

procedure TForm1.Panel30Resize(Sender: TObject);
begin
  DBChemComboBox1.Width:=Panel30.ClientWidth;
end;

procedure TForm1.ComboBox7Change(Sender: TObject);
begin
  if not (ComboBox7.ItemIndex in [0..2]) then ComboBox7.ItemIndex:=2;
  DBChemText1.TryCorrect:=TChemTryCorrect(ComboBox7.ItemIndex);
  DBChemListBox1.TryCorrect:=TChemTryCorrect(ComboBox7.ItemIndex);
  DBChemComboBox1.TryCorrect:=TChemTryCorrect(ComboBox7.ItemIndex);
end;

procedure TForm1.MaskEdit7Change(Sender: TObject);
begin
  DBChemText1.SubPercent:=StrToInt(MaskEdit7.Text);
  DBChemListBox1.SubPercent:=StrToInt(MaskEdit7.Text);
  DBChemComboBox1.SubPercent:=StrToInt(MaskEdit7.Text);
end;

procedure TForm1.SetGrid;
var c,r:integer;
begin
  with StringGrid1 do begin
    Cells[0,0]:='Sub% \ TryCorr.';
    for r:=1 to RowCount-1 do begin
      Cells[0,r]:=IntToStr(30+10*r);
      for c:=1 to ColCount-1 do Cells[c,r]:='La3ba3cu6o13.5';
    end;
    Cells[1,0]:='tchNone';
    Cells[2,0]:='tchCareful';
    Cells[3,0]:='tchAll';
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetLabelsPage;
  SetBoxesPage;
  SetDBPage;
  SetGrid;
  StringGrid2.Cells[0,0]:='H2O';
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
var T:TChemString;
begin
  T:=TChemString.Create;
  try
    case Col of
      0,1 : T.TryCorrect:=tchNone;
        2 : T.TryCorrect:=tchCareful;
        3 : T.TryCorrect:=tchAll;
    end;
    T.SubPercent:=30+10*Row;
    T.Caption:=StringGrid1.Cells[Col,Row];

    with StringGrid1.Canvas do begin
      if gdFixed in State then
        Brush.Color:=StringGrid1.FixedColor
      else if gdSelected in State then
        Brush.Color := clActiveCaption
      else
        Brush.Color:=StringGrid1.Color;
      Brush.Style:=bsSolid;
      FillRect(Rect);
      Brush.Style:=bsClear;
      Font:=StringGrid1.Font;
      if gdSelected in State then Font.Color:=clWhite;
    end;
    T.PaintTo(StringGrid1.Canvas,Rect);
    if gdFocused in State then
      StringGrid1.Canvas.DrawFocusRect(Rect);
  finally
    T.Free;
  end;
end;

procedure TForm1.Panel34Resize(Sender: TObject);
var i:integer;
begin
  with StringGrid1 do begin
    for i:=0 to ColCount-2 do
      ColWidths[i]:=ClientWidth div ColCount;
    ColWidths[ColCount-1]:=ClientWidth-(ColCount-1)*ColWidths[0];
    for i:=0 to RowCount-2 do
      RowHeights[i]:=ClientHeight div RowCount;
    RowHeights[RowCount-1]:=ClientHeight-(RowCount-1)*RowHeights[0];
  end;
end;

procedure TForm1.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
var T:TChemString;
begin
  T:=TChemString.Create;
  try
    T.TryCorrect:=tchAll;
    T.SubPercent:=80;
    T.Caption:=Field.AsString;

    with DBGrid1.Canvas do begin
      if gdFixed in State then
        Brush.Color:=DBGrid1.FixedColor
      else if gdSelected in State then
        Brush.Color := clActiveCaption
      else
        Brush.Color:=DBGrid1.Color;
      Brush.Style:=bsSolid;
      FillRect(Rect);
      Brush.Style:=bsClear;
      Font:=StringGrid1.Font;
      if gdSelected in State then Font.Color:=clWhite;
    end;
    T.PaintTo(DBGrid1.Canvas,Rect);
    if gdFocused in State then
      DBGrid1.Canvas.DrawFocusRect(Rect);
  finally
    T.Free;
  end;  
end;

procedure TForm1.StringGrid2DrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
var T:TChemString;
begin
  T:=TChemString.Create;
  try
    T.TryCorrect:=tchAll;
    T.SubPercent:=80;
    T.Caption:=StringGrid2.Cells[0,0];
    with StringGrid2.Canvas do begin
      Brush.Color:=StringGrid2.Color;
      Brush.Style:=bsSolid;
      FillRect(Rect);
      Brush.Style:=bsClear;
      Font:=StringGrid2.Font;
    end;
    T.PaintTo(StringGrid2.Canvas,Rect);
  finally
    T.Free;
  end;  
end;

procedure TForm1.ChemLabel2Click(Sender: TObject);
begin
  with CheckBox5 do Checked:=not Checked;
end;

procedure TForm1.ChemLabel3Click(Sender: TObject);
begin
  RadioButton1.Checked:=True;
end;

end.
